var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
define(["require", "exports", "date-fns", "./abstract-scope"], function (require, exports, date_fns_1, abstract_scope_1) {
    Object.defineProperty(exports, "__esModule", { value: true });
    var MinuteSelectionStrategy = (function (_super) {
        __extends(MinuteSelectionStrategy, _super);
        function MinuteSelectionStrategy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        MinuteSelectionStrategy.prototype.next = function (selectedDate) {
            return date_fns_1.addMinutes(selectedDate, 1);
        };
        MinuteSelectionStrategy.prototype.previous = function (selectedDate) {
            return date_fns_1.addMinutes(selectedDate, -1);
        };
        MinuteSelectionStrategy.prototype.getItems = function (selectedDate) {
            var initialDate = [selectedDate]
                .map(function (date) { return date_fns_1.startOfDay(date); })
                .map(function (date) { return date_fns_1.startOfHour(date); })
                .pop();
            var minutes = Array.from(new Array(12), function (_, index) { return date_fns_1.addMinutes(initialDate, index * 5); });
            return minutes;
        };
        MinuteSelectionStrategy.prototype.formatDate = function (date) {
            return date_fns_1.format(date, 'mm');
        };
        MinuteSelectionStrategy.prototype.title = function (date) {
            return date_fns_1.format(date, 'DD. MM. YYYY');
        };
        MinuteSelectionStrategy.prototype.isEqual = function (a, b) {
            return this.previousScope().isEqual(a, b)
                && date_fns_1.getMinutes(a) === date_fns_1.getMinutes(b);
        };
        return MinuteSelectionStrategy;
    }(abstract_scope_1.AbstractScope));
    exports.MinuteSelectionStrategy = MinuteSelectionStrategy;
});
